/*
 *-----------------------------------------------------------------------------
 * Filename: kernel-compat.h
 **-----------------------------------------------------------------------------
 ** Copyright (c) 2002-2013, Intel Corporation.
 **
 ** Permission is hereby granted, free of charge, to any person obtaining a copy
 ** of this software and associated documentation files (the "Software"), to deal
 ** in the Software without restriction, including without limitation the rights
 ** to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 ** copies of the Software, and to permit persons to whom the Software is
 ** furnished to do so, subject to the following conditions:
 **
 ** The above copyright notice and this permission notice shall be included in
 ** all copies or substantial portions of the Software.
 **
 ** THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 ** IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 ** FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 ** AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 ** LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 ** OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 ** THE SOFTWARE.
 *
 *
 *-----------------------------------------------------------------------------
 * Description:
 **  This file contains kernel version comapability macors information. 
 **-----------------------------------------------------------------------------
*/

 

#if LINUX_VERSION_CODE >=KERNEL_VERSION(3,10,0)
#define GTT(dev_priv) (dev_priv)
#else
#define GTT(dev_priv) (dev_priv->mm.gtt)
#endif

#if LINUX_VERSION_CODE < KERNEL_VERSION(3,10,0)
#define	ADD_GTT_MTRR(base,sz,type,inc)	mtrr_add(base,sz,type,inc)
#define DEL_GTT_MTRR(mtrr,base,sz)	mtrr_del(mtrr,base,sz) 
#else
#define ADD_GTT_MTRR(base,sz,type,inc)	0
#define DEL_GTT_MTRR(mtrr,base,sz)		 
#endif
	
